{{! template-lint-disable require-input-label no-down-event-binding }}
<div class="qrocm-proposal">
  {{#each this.proposalBlocks as |block index|}}

    {{#if block.showText}}
      <MarkdownToHtmlUnsafe @markdown={{block.text}} @extensions="remove-paragraph-tags" class="qrocm-proposal__label" />
    {{/if}}
    {{#if (eq block.type "select")}}
      <div class="challenge-response__proposal challenge-response__proposal--selector">
        <PixSelect
          data-test="challenge-response-proposal-selector"
          @isDisabled={{@isAnswerFieldDisabled}}
          @label={{block.ariaLabel}}
          @screenReaderOnly={{true}}
          @placeholder={{block.placeholder}}
          @value={{get @answersValue block.input}}
          @hideDefaultOption={{true}}
          @options={{block.options}}
          @onChange={{fn this.onChange block.input}}
          @size="big"
          @id="{{block.input}}"
        />
      </div>
    {{else if (eq block.type "input")}}
      {{#if block.input}}
        {{#if block.text}}
          <label for="{{block.input}}">
            <MarkdownToHtmlUnsafe
              @markdown={{block.text}}
              @extensions="remove-paragraph-tags"
              class="qrocm-proposal__label"
              data-test="qrocm-label-{{index}}"
            />
          </label>
        {{/if}}

        {{#if (eq @format "paragraphe")}}
          <Textarea
            class="challenge-response__proposal challenge-response__proposal--paragraph"
            data-test="challenge-response-proposal-selector"
            rows="5"
            name={{block.randomName}}
            placeholder={{block.placeholder}}
            autocomplete="nope"
            id="{{block.input}}"
            @value={{mut (get @answersValue block.input)}}
            disabled={{@isAnswerFieldDisabled}}
            aria-label={{block.ariaLabel}}
            {{on "keydown" this.onInputChange}}
          />
        {{else if (eq @format "phrase")}}
          <Input
            class="challenge-response__proposal challenge-response__proposal--sentence"
            data-test="challenge-response-proposal-selector"
            @type="text"
            name={{block.randomName}}
            placeholder={{block.placeholder}}
            autocomplete="nope"
            id="{{block.input}}"
            @value={{mut (get @answersValue block.input)}}
            disabled={{@isAnswerFieldDisabled}}
            aria-label={{block.ariaLabel}}
            {{on "keydown" this.onInputChange}}
          />
        {{else if (eq @format 'choix')}}
          <div class="challenge-response__proposal challenge-response__proposal--choice" style={{block.minWidth}}>
            <PowerSelect 
              @options={{block.choices}}
              @onChange={{(fn this.onSelectChange block.input)}}
              @selected={{get this.selectedvalues block.input}}
              name={{block.input}}
              placeholder={{block.placeholder}}
              autocomplete="off"
              id="{{block.text}}"
              disabled={{@answer}}
              aria-label={{block.ariaLabel}}
              as |name|>
              {{name}}           
            </PowerSelect>
          </div>

        {{else if (eq @format 'texte à trous')}}
          {{#if block.text}}
            <label for="{{block.text}}"></label>
          {{/if}}
          <Input class="challenge-response__proposal"
                size="{{get-qroc-input-size @format}}"
                @type="text"
                name={{block.input}}
                placeholder={{block.placeholder}}
                autocomplete="off"
                id="{{block.text}}"
                @value={{mut (get @answersValue block.input)}}
                disabled={{@answer}}
                aria-label={{block.ariaLabel}}
                onkeydown={{action 'onInputChange'}} />
        {{else}}
          <Input
            class="challenge-response__proposal"
            data-test="challenge-response-proposal-selector"
            size="{{get-qroc-input-size @format}}"
            @type="text"
            name={{block.randomName}}
            placeholder={{block.placeholder}}
            autocomplete="nope"
            id="{{block.input}}"
            @value={{mut (get @answersValue block.input)}}
            disabled={{@isAnswerFieldDisabled}}
            aria-label={{block.ariaLabel}}
            {{on "keydown" this.onInputChange}}
          />
        {{/if}}
      {{/if}}
    {{/if}}
  {{/each}}
</div>